// Drawing of screen 2 (FILE LOAD)                             ///
#include <stdio.h>
#include <stdlib.h>
#include <vga.h>
#include <vgakeyboard.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include "CharMap.h"
#include "loopdata.h"
#include "input.h"
#include "gui.h"

static char working_dir[1024];
static char top_file_name[1024];

static int top_file_in_dir = 0;

static char title[] = "LOAD PCM WAVE FILE";
static char ok[] = "OPEN";
static char cancel[] = "CANCEL";
static const int FILES_TOP = 8;
static const int FILES_SHOWN = 58 - 8;
static int OKButton;

static void erase_directory_listing()
{
	char clear_listing[79];
	int i;
	clear_listing[78]=0;
	vga_waitretrace();
	for (i=0;i<78;i++) clear_listing[i]=' ';
	for (i=FILES_TOP; i<59; i++) DrawStr(clear_listing, 1, i, 0x00);
}


static void draw_directory()
{
	DIR * the_dir;
	struct dirent * dir_entry = NULL;
	char * dir_name_line;
	static char clear_dir[81];
	static int first_time = 1;
	char * get_dir_display;
	int len_dir, i, y;
	long int dir_pos;
	getcwd(working_dir, 1024);
	the_dir = opendir(working_dir);
	// get either pathname for dir or right 80 chars //
	// draw it centered on top of screen 		 //
	if (first_time == 1)
	{
		first_time = 0;
		clear_dir[80]=0;
		for (i=0;i<80;i++) clear_dir[i]=' ';
	}
	len_dir = strlen(working_dir);
	if (len_dir < 80) get_dir_display = working_dir;
	else
	{
		get_dir_display = working_dir + len_dir;
		get_dir_display -= 80;
	}
	DrawStr(clear_dir, 0, FILES_TOP-2, 0x00);
	DrawStr(get_dir_display, 40-strlen(get_dir_display)/2,
				FILES_TOP-2, 0xb0);
	erase_directory_listing();
	// now draw all the directory entries //
	if (the_dir == NULL) return;
	// get the number of entries in dir //
	// if there are less entries then top_file_in_dir //
	// set top_file_in_dir to last file//
	dir_pos = telldir(the_dir);
	i = 0;
	while(1)
	{	
		dir_entry = readdir(the_dir);   
		if (dir_entry == NULL) break;
		i++;
	}
	if (i <= top_file_in_dir) top_file_in_dir = i-1;
	seekdir(the_dir, dir_pos);
	// eat excess entries at top of dir //
	i = top_file_in_dir;
	while (i > 0) {dir_entry = readdir(the_dir); i--;}
	// get dir strings until end or screen is full //
	i = FILES_SHOWN;
	y = FILES_TOP;
	while (i > 0)
	{
		dir_entry = readdir(the_dir);
		// record top name //
		if (y == FILES_TOP)
		{
			if (dir_entry != NULL)
			strcpy(top_file_name, dir_entry->d_name);
			else	top_file_name[0]=0;
		}
		if (dir_entry == NULL) break;
		dir_name_line = dir_entry->d_name;
		len_dir = strlen(dir_name_line);
		if (len_dir > 78) dir_name_line += len_dir - 78;		
		DrawStr(dir_name_line, 2, y, (y==FILES_TOP)?0xf0:0x80);
		y++; i--;
	}
	closedir (the_dir);
}

void draw_static_screen2()
{
	DrawStr(title, 40-strlen(title)/2 , 1, 0x80);
	blue_frame_ch(40-strlen(title)/2, 1, 40+strlen(title)/2, 1); 
	DrawStr(ok, 10, 4, 0x80); 
	DrawStr(cancel, 70-strlen(cancel), 4, 0x80);
	active_frame_ch(10,4,10+strlen(ok), 4);
	blue_frame_ch(70-strlen(cancel), 4, 70, 4);
	blue_frame_ch(1, FILES_TOP, 78, 58);	
	OKButton = 1;
	top_file_name[0]=0;
	draw_directory();
}

int load_file_into_loop()
{
	extern int Y_SCR1; // the cursor on the loop display!
	int err; int err_len; char * err_mesg; int i;
	lockLoop(Y_SCR1);  // set the mutex so that audio doesn't try to use loop
	err = loadLoop(Y_SCR1, top_file_name); // load the file
	unlockLoop(Y_SCR1); // let the audio go on it's merry way
	if (err == 1) return err;
	// now display any evilness which may have occurred //
	err_len = strlen(llError); err_mesg = llError;
	if (err_len > 80) err_mesg += err_len - 80;
	for (i=0;i<80;i++) DrawAscChar(' ', i, FILES_TOP-2, 0x00);
	DrawStr(err_mesg, 40-strlen(err_mesg)/2, FILES_TOP-2, 0xb0);
	return err;
}



void handle_keyboard_screen2()
{
	struct stat stbuf;
	if (is_pushed(SCANCODE_ENTER)) 
	{
		if (OKButton == 0) {switch_screen(1); return;}
		if (0 != stat(top_file_name, &stbuf) ) return;
		if (stbuf.st_mode & S_IFDIR)
		{
			chdir (top_file_name);
			top_file_in_dir=0;
			draw_directory();
			return;
		}
		if (stbuf.st_mode & S_IFREG)
			if (load_file_into_loop())
			{
				switch_screen(1); 
				return;
			}
	}
	if (is_pushed(SCANCODE_ESCAPE)) {switch_screen(1); return;}
	if (is_pushed(SCANCODE_SPACE))
	{
		if (0 != stat(top_file_name, &stbuf) ) return;
		if (stbuf.st_mode & S_IFDIR)
		{
			chdir (top_file_name);
			top_file_in_dir=0;
			draw_directory();
			return;
		}
		
	}
	
	if (is_pushed(SCANCODE_CURSORBLOCKUP))
		if (top_file_in_dir>0)
		{ top_file_in_dir--; draw_directory();}
	if (is_pushed(SCANCODE_CURSORBLOCKDOWN))
		{ top_file_in_dir++; draw_directory();}
	
	if (is_pushed(SCANCODE_PAGEUP))
	{
		top_file_in_dir -= 10; 
		if (top_file_in_dir < 0) top_file_in_dir = 0;
		draw_directory();
	}
	if (is_pushed(SCANCODE_PAGEDOWN))
		{ top_file_in_dir += 10; draw_directory();}
	if (is_pushed(SCANCODE_CURSORBLOCKLEFT) ||
		is_pushed(SCANCODE_CURSORBLOCKRIGHT) )
	{
		OKButton ^= 1;
		if (OKButton == 1)
		{
			blue_frame_ch(70-strlen(cancel), 4, 70, 4);
			active_frame_ch(10,4,10+strlen(ok),4);
		}
		else
		{
			active_frame_ch(70-strlen(cancel), 4, 70, 4);
			blue_frame_ch(10,4,10+strlen(ok),4);
		}
	}

}

